

var gesturesSetUp = false;
var ua = navigator.userAgent.toLowerCase();
var isAndroid = ua.indexOf("android") > -1;
var pinchDistance = 0;
var pinchScale = 1, lastPinchScale = 1;
var startTouches = [], currentTouches = [];
var zooms = 0;
var zoomStyle = "-moz-transform: scale(0.8, 0.8);zoom: 0.8;zoom: 80%";

///*
 //* -moz-transform: scale(0.8, 0.8); /!* Moz-browsers *!/
  // zoom: 0.8; /!* Other non-webkit browsers *!/
  // zoom: 80%; /!* Webkit browsers *!/
  //  * @param text
  // *!/

var setText = function(text) {
    document.getElementById('numPages').innerHTML = text;
  }

var getZoomFactor = function(newZoom) {
  var zoom;
  if ( newZoom > 1 )
    zoom = ((1 - newZoom)/2) + 1;
  else
    zoom = ((1-newZoom)/2) + (1-newZoom);
  return zoom;
}

var updateEle = function(eleName, newZoom) {
  var zoom = getZoomFactor(newZoom);
  var el = document.getElementById(eleName);
  el.style.cssText = zoomStyle.replace("0.8", zoom).replace("80%", (zoom*100)+"%");
}

document.addEventListener('textlayerrendered', function (e) {
  if (gesturesSetUp || e.detail.pageNumber !== PDFViewerApplication.page) {
    return;
  }
  var viewer = document.getElementById('viewer');
  // http://blog.fspm.jp/2014/06/androidpinch-inoutjsgesturestart.html

  var funcGestureStart = function (e, pinchScale) {};

  var funcGestureChange = function (e, pinchScale, lastPinchScale) {
    var diff = pinchScale / (pinchScale - lastPinchScale);
    if ( diff > .1 ) {
      updateEle('viewer', pinchScale);
    }
  };
  var funcGestureEnd = function(e) {
    var steps = 1;

    if ( pinchScale > 1 ) {
      PDFViewerApplication.zoomIn(steps);
    } else {
      PDFViewerApplication.zoomOut(steps);
    }
    pinchScale = 0, lastPinchScale = 0;
  };

  var funcTouchStart = function(e){
    if(e.touches.length > 1){
      startTouches = e.touches;
      zooms=0;
      pinchDistance = Math.sqrt(Math.pow((e.touches[1].pageX - e.touches[0].pageX),2)+Math.pow((e.touches[1].pageY - e.touches[0].pageY),2));
      funcGestureStart(e);
    } else {
      pinchDistance = 0;
      pinchScale = 1;
      lastPinchScale = pinchScale;
    }
  }

  var funcTouchMove = function (e) {
    if (pinchDistance <= 0 || e.touches.length < 2) {
      return;
    }
    currentTouches = e.touches;
    var newDistance = Math.sqrt(Math.pow((e.touches[1].pageX - e.touches[0].pageX),2)+Math.pow((e.touches[1].pageY - e.touches[0].pageY),2));
    lastPinchScale = pinchScale;

    pinchScale = newDistance / pinchDistance;
    var newZoom = getZoomFactor(pinchScale);

    setText(newZoom);
    var event = { scale: pinchScale };
    var mod = funcGestureChange(event, pinchScale, lastPinchScale);
       if ( mod == 0 ) { // reset starting point
         zooms++;
         //if ( zooms > 1 ) alert("zooms:"+zooms);
         startTouches = currentTouches;
         pinchScale = 1;
         pinchDistance = Math.sqrt(Math.pow((e.touches[1].pageX - e.touches[0].pageX),2)+Math.pow((e.touches[1].pageY - e.touches[0].pageY),2));
         //setTimeout(function() {
           funcTouchStart(e);
         //}, 0);
         //e.cancelBubble();
       }
  }
  var funcTouchEnd = function (e) {
    if (pinchDistance <= 0 || e.touches.length > 0) {
      return;
    }
    var event = {scale: pinchScale};
    funcGestureEnd(event, pinchScale);
  }

  // iOS
  document.body.addEventListener('gesturestart', funcGestureStart, false);
  document.body.addEventListener('gesturechange', funcGestureChange, false);
  document.body.addEventListener('gestureend', funcGestureEnd, false);

  // Android
  if (isAndroid) {
    document.body.addEventListener('touchstart',funcTouchStart, false);
    document.body.addEventListener('touchmove', funcTouchMove, false);
    document.body.addEventListener('touchend', funcTouchEnd, false);
  }
  gesturesSetUp = true;
}, true);
document.documentElement.addEventListener('touchstart', function (event) {
  if (event.touches.length > 1) {
    event.preventDefault();
  }
}, false);

