window.forge = {}; window.forge.config = {
    "author": "leif.ullman@kidreports.com", 
    "config_hash": "f1f8fdbed0fa6ced596ba83fdaa297de25f25caf", 
    "config_version": "4", 
    "core": {
        "android": {
            "disable_ics_acceleration": true, 
            "minimum_version": "21", 
            "package_name": "com.kidreports.app.bigbluemarble"
        }, 
        "general": {
            "httpd": {
                "certificate_password": "kidreports", 
                "certificate_path": "localhost.p12", 
                "port": 31929, 
                "url": "https://localhost:31929/src/index.html"
            }, 
            "logging": {
                "level": "DEBUG"
            }, 
            "reload": true, 
            "reload_forcewifi": true, 
            "trusted_urls": [
                "https://secure.kidreports.com", 
                "192.168.0.14"
            ]
        }, 
        "ios": {
            "device_family": "any", 
            "disable_web_storage_backup": true, 
            "package_name": "com.kidreports.app.bigbluemarble", 
            "webview": "WKWebView"
        }, 
        "osx": {
            "package_name": "io.trigger.forgecdcf60ca348a11e5810a1231392b77b0"
        }
    }, 
    "description": "Big Blue Marble Native Application", 
    "flags": {
        "android_uses_cleartext_traffic": true
    }, 
    "homepage": "www.kidreports.com", 
    "modules": {
        "bolts": {
            "version": "1.9.0"
        }, 
        "camera": {
            "version": "2.3"
        }, 
        "capture": {
            "config": {
                "usage_description": "View and Send Photos/Videos to attach to an activity stream"
            }, 
            "version": "2.26"
        }, 
        "contact": {
            "disabled": true, 
            "version": "2.12"
        }, 
        "damn_you_form_assist": {
            "version": "2.2"
        }, 
        "deviceinfo": {
            "version": "1.0.6"
        }, 
        "display": {
            "config": {
                "fullscreen": {
                    "ios7": "no-statusbar"
                }, 
                "statusbar": {
                    "ios": {
                        "hidden": true, 
                        "style": "default", 
                        "transparent": true
                    }
                }
            }, 
            "version": "2.14"
        }, 
        "file": {
            "config": {
                "usage_description": "View and Send Photos/Videos to attach to an activity stream"
            }, 
            "version": "2.27"
        }, 
        "flurry": {
            "config": {
                "android_api_key": "5SD298VDYKKBNY2KKYYD", 
                "debug": true, 
                "ios_api_key": "H75NVNKPIZXNI7124AVJ"
            }, 
            "disabled": true, 
            "version": "2.4"
        }, 
        "icons": {
            "config": {
                "android": {
                    "144": "assets/android/icon/drawable-xxxhdpi-icon.png", 
                    "192": "assets/android/icon/drawable-xxxhdpi-icon.png", 
                    "48": "assets/android/icon/drawable-xxxhdpi-icon.png", 
                    "72": "assets/android/icon/drawable-xxxhdpi-icon.png", 
                    "96": "assets/android/icon/drawable-xxxhdpi-icon.png"
                }, 
                "ios": {
                    "1024": "assets/ios/icon/icon-1024.png", 
                    "114": "assets/ios/icon/icon-114.png", 
                    "120": "assets/ios/icon/icon-120.png", 
                    "144": "assets/ios/icon/icon-144.png", 
                    "152": "assets/ios/icon/icon-152.png", 
                    "167": "assets/ios/icon/icon-167.png", 
                    "180": "assets/ios/icon/icon-180.png", 
                    "57": "assets/ios/icon/icon-57.png", 
                    "72": "assets/ios/icon/icon-72.png", 
                    "76": "assets/ios/icon/icon-76.png", 
                    "prerendered": true
                }
            }, 
            "version": "2.9"
        }, 
        "launchimage": {
            "config": {
                "android": {
                    "background-color": "#ffffff", 
                    "background-size": "auto", 
                    "landscape": "assets/launch/1536x2048.png", 
                    "portrait": "assets/launch/2048x1536.png"
                }, 
                "hide-manually": true, 
                "ios": {
                    "wC_hC": "assets/launch/1334x750.png", 
                    "wC_hR": "assets/launch/1080x1920.png", 
                    "wR_hC": "assets/launch/1920x1080.png", 
                    "wR_hR": "assets/launch/2732x2048.png"
                }
            }, 
            "version": "2.13"
        }, 
        "media": {
            "config": {}, 
            "version": "2.9"
        }, 
        "notification": {
            "version": "2.8"
        }, 
        "oauth": {
            "config": {
                "providers": [
                    {
                        "authorization_endpoint": "https://www.facebook.com/dialog/oauth", 
                        "authorization_scope": "public_profile publish_actions", 
                        "client_id": "186253524817541", 
                        "client_secret": "9d5c55f7b41ad141c1d50a7ebef521f4", 
                        "name": "facebook", 
                        "redirect_uri": "https://secure.kidreports.com/utils/oauth2redirect", 
                        "token_endpoint": "https://graph.facebook.com/v2.10/oauth/access_token"
                    }
                ], 
                "redirect_scheme": "com.kidreports.oauth2"
            }, 
            "version": "1.1"
        }, 
        "parameters": {
            "config": {
                "PushwooshAppID": "35A8C-9505B", 
                "bumpme": "16"
            }, 
            "version": "2.0"
        }, 
        "pgcapture": {
            "version": "0.2.25"
        }, 
        "platform": {
            "version": "2.3"
        }, 
        "prefs": {
            "version": "2.3"
        }, 
        "pushwoosh": {
            "version": "3.8.0"
        }, 
        "request": {
            "config": {
                "ats": [
                    {
                        "NSExceptionAllowsInsecureHTTPLoads": true, 
                        "domain": "localhost"
                    }
                ]
            }, 
            "version": "2.12"
        }, 
        "share": {
            "version": "1.3"
        }, 
        "tabs": {
            "version": "3.7"
        }, 
        "ui": {
            "version": "2.1"
        }, 
        "urlhandler": {
            "config": {
                "scheme": "kidreports"
            }, 
            "version": "2.3"
        }
    }, 
    "name": "Big Blue Marble", 
    "platform_version": "v2.9.2", 
    "trigger_domain": "https://trigger.io", 
    "uuid": "cdcf60ca348a11e5810a1231392b77b0", 
    "version": "2.20.0", 
    "version_code": "1635270195"
}; window.forge.module_mapping = {
    "bolts": "bolts", 
    "camera": "camera", 
    "capture": "capture", 
    "damn_you_form_assist": "damn_you_form_assist", 
    "deviceinfo": "deviceinfo", 
    "display": "display", 
    "file": "file", 
    "icons": "icons", 
    "launchimage": "launchimage", 
    "media": "media", 
    "notification": "notification", 
    "oauth": "oauth", 
    "parameters": "parameters", 
    "pgcapture": "pgcapture", 
    "platform": "platform", 
    "prefs": "prefs", 
    "pushwoosh": "pushwoosh", 
    "request": "request", 
    "share": "share", 
    "tabs": "tabs", 
    "ui": "ui", 
    "urlhandler": "urlhandler"
}; window.forge.config.development = false;